#include <stdio.h>
#include <stdlib.h>

#include "flipull.h"

namespace Flipuller{
	int problem_load(Problem* prob, FILE* in)
	{
		char line[0x100];
		int x, y;

	#define GETLINE(buf, in) \
		if(!fgets(buf, sizeof(buf), in)) { goto ERROR; }

		GETLINE(line, in);
		if((prob->quota = atoi(line)) < 0) goto ERROR;

		GETLINE(line, in);
		if((prob->block = atoi(line)) < 0) goto ERROR;

		for(y = 0; y < FLIPULL_H; ++y){
			GETLINE(line, in);
			for(x = 0; x < FLIPULL_W; ++x){
				if((prob->cell[y][x] = ch2cell(line[x])) == CELL_INVALID) goto ERROR;
			}
		}

	#undef GETLINE

		return 1;

	ERROR:
		return 0;
	}

	int problem_save(const Problem* prob, FILE* out)
	{
		char c;
		int x, y;

		fprintf(out, "%d\n", prob->quota);
		fprintf(out, "%d\n", prob->block);

		for(y = 0; y < FLIPULL_H; ++y){
			for(x = 0; x < FLIPULL_W; ++x){
				if((c = cell2ch(prob->cell[y][x])) == CH_INVALID) goto ERROR;
				putc(c, out);
			}
			putc('\n', out);
		}

		return 1;

	ERROR:
		return 0;
	}

	int ch2cell(char c)
	{
		int cell;

		switch(c){
		case CH_EMPTY: return CELL_EMPTY;
		case CH_WALL: return CELL_WALL;
		case CH_PIPE_H: return CELL_PIPE_H;
		case CH_PIPE_V: return CELL_PIPE_V;
		case CH_EXTEND: return CELL_EXTEND;
		default:
			cell = c-'0';
			return (cell >= 0 ? cell : CELL_INVALID);
		}
	}

	char cell2ch(int cell)
	{
		char c;

		switch(cell){
		case CELL_EMPTY: return CH_EMPTY;
		case CELL_WALL: return CH_WALL;
		case CELL_PIPE_H: return CH_PIPE_H;
		case CELL_PIPE_V: return CH_PIPE_V;
		case CELL_EXTEND: return CH_EXTEND;
		default:
			c = '0'+cell;
			return (c >= '0' ? c : CH_INVALID);
		}
	}
};
