#ifndef __KSK_FLIPULLER_FLIPULL_H
#define __KSK_FLIPULLER_FLIPULL_H

#include <stdio.h>

#define FLIPULL_W 10
#define FLIPULL_H 12

#define BLOCK_WILD 99

#define CELL_EMPTY -1
#define CELL_WALL -2
#define CELL_PIPE_H -3
#define CELL_PIPE_V -4
#define CELL_EXTEND 999
#define CELL_INVALID -99

#define CH_EMPTY ' '
#define CH_WALL '#'
#define CH_PIPE_H '='
#define CH_PIPE_V '|'
#define CH_EXTEND 'S'
#define CH_INVALID '\0'

namespace Flipuller{
	typedef struct Problem_tag{
		int quota;
		int block;
		int cell[FLIPULL_H][FLIPULL_W];
	} Problem;

	int problem_load(Problem* prob, FILE* in);
	int problem_save(const Problem* prob, FILE* out);

	int ch2cell(char c);
	char cell2ch(int cell);
};

#endif /* __KSK_FLIPULLER_FLIPULL_H */
