#include <stdio.h>
#include <stdlib.h>

#include "flipull.h"
#include "solver.h"

static void error(const char* msg)
{
    fputs(msg, stderr);
    putc('\n', stderr);
    exit(1);
}

static void usage()
{
    error("Usage: flipuller <problem file>");
}

int main(int argc, char** argv)
{
    FILE* in;
    Problem prob;
    Solution sol;
    int i;

    if(argc != 2) usage();

    if(!(in = fopen(argv[1], "r"))) error("Can't open problem file");
    if(!problem_load(&prob, in)){
        fclose(in);
        error("Problem format error");
    }
    fclose(in);

    //problem_save(&prob, stdout);

    if(solve(&prob, &sol)){
        for(i = 0; i < sol.num_move; ++i){
            printf("%d\n", sol.move[i]);
        }
    }
    else{
        puts("No solution found...");
    }

    return 0;
}
