/**
 * Ƃ肠m[~XTver
 */

#include <stdio.h>

#include "flipull.h"
#include "solver.h"

#define NELEMS(array) (sizeof(array) / sizeof((array)[0]))

#define DIR_H 1
#define DIR_V 2

namespace Flipuller{
	typedef struct Position_tag{
		int quota;  // m}
		int num_block;      // ubN
		int block;  // ێubN
		int cell[(FLIPULL_W+2) * (FLIPULL_H+2)];    // }bv(OɌ1̕ǂ݂)
		int effect[FLIPULL_H];      // eYW̗
		int effect_dir[FLIPULL_H];  // ̕(/)
	} Position;

	int coord1(int x, int y)
	{
		return x+1 + (FLIPULL_W+2)*(y+1);
	}

	int pos_get_cell(const Position* pos, int x, int y)
	{
		return pos->cell[coord1(x,y)];
	}

	void pos_set_cell(Position* pos, int x, int y, int value)
	{
		pos->cell[coord1(x,y)] = value;
	}

	void pos_print(const Position* pos, FILE* out)
	{
		int x, y;

		fprintf(out, "%d\n", pos->quota);
		fprintf(out, "%d\n", pos->block);

		for(y = 0; y < FLIPULL_H; ++y){
			for(x = 0; x < FLIPULL_W; ++x){
				putc(cell2ch(pos_get_cell(pos, x, y)), out);
			}
			putc('\t', out);
			fprintf(out, "(%d,%d) %c\n",
					pos->effect[y]%(FLIPULL_W+2) - 1, pos->effect[y]/(FLIPULL_W+2) - 1,
					pos->effect_dir[y] == DIR_H ? 'H' : 'V');
		}
	}

	void pos_update_effect(Position* pos)
	{
		int coord;
		int y;

		for(y = 0; y < FLIPULL_H; ++y){
			/* E[JnďQɓ܂ō */
			coord = coord1(FLIPULL_W-1, y);
			while(pos->cell[coord] == CELL_EMPTY ||
				  pos->cell[coord] == CELL_PIPE_H) --coord;
			/* QubNȂ΂ƂȂ */
			if(pos->cell[coord] >= 0){
				pos->effect[y] = coord;
				pos->effect_dir[y] = DIR_H;
				continue;
			}

			/* QubNłȂꍇAɏQɓ܂ŉ */
			++coord;
			coord += FLIPULL_W+2;
			while(pos->cell[coord] == CELL_EMPTY ||
				  pos->cell[coord] == CELL_PIPE_V) coord += FLIPULL_W+2;
			/* ԂƂ낪ƂȂ */
			pos->effect[y] = coord;
			pos->effect_dir[y] = DIR_V;
		}
	}

	void pos_erase_block(Position* pos, int coord)
	{
		int coord_up;

		pos->cell[coord] = CELL_EMPTY;
		--pos->num_block;

		/* ɐςݏdȂĂubN1iƂ */
		for(coord_up = coord - (FLIPULL_W+2); pos->cell[coord_up] >= 0; coord_up -= FLIPULL_W+2){
			pos->cell[coord_up + FLIPULL_W+2] = pos->cell[coord_up];
			pos->cell[coord_up] = CELL_EMPTY;
		}
	}

	void pos_proceed(const Position* pos_orig, int move, Position* pos_new)
	{
		int block;
		int coord, coord_tmp;
		int d_coord;
		int disable_xcg = 0;

		block = pos_orig->block;

		coord = pos_orig->effect[move];
		/* c`FbN */
		d_coord = (pos_orig->effect_dir[move] == DIR_H ? -1 : FLIPULL_W+2);

		if(pos_orig->cell[coord] < 0) return;

		/* do_solve() Ŕ肵Ă̂łƂ肠̃`FbN͏ȗ */
	#if 0
		/* Ă}XێubNƓłȂ΂ȂȂ(1UPubN̏ꍇ͍XɗׂKv) */
		coord_tmp = coord;
		while(pos_orig->cell[coord_tmp] == CELL_EXTEND) coord_tmp += d_coord;
		if((block != BLOCK_WILD && pos_orig->cell[coord_tmp] != block)) return;
	#endif

		*pos_new = *pos_orig;

		coord_tmp = coord;
		while(pos_orig->cell[coord_tmp] == CELL_EXTEND) coord_tmp += d_coord;
		if(block == BLOCK_WILD)
			block = pos_orig->cell[coord_tmp]; // ChJ[h1UPɕǂɓꍇȂ邯ǁAm[~XȂ炻͂Ȃ̂œʖ
		/**
		 * ŏSɓꍇ͓ʂȏKv(GB)
		 * 瓖ꍇ͐΂ɌNȂ
		 * c瓖ꍇłAS̒ɕʎ̃ubNɓꍇ͌NȂ
		 */
		if(pos_orig->cell[coord] == CELL_EXTEND){
			if(d_coord == -1 || block != pos_orig->cell[coord_tmp]) disable_xcg = 1;
		}

		//if(block == BLOCK_WILD && pos_orig->cell[coord] != CELL_EXTEND) block = pos_orig->cell[coord];
		pos_erase_block(pos_new, coord);
		for(;;){
			coord += d_coord;
			/* 1UPubN͒Pɏ */
			if(pos_new->cell[coord] == CELL_EXTEND){
				pos_erase_block(pos_new, coord);
			}
			/* ރubN͂̂܂܏ */
			else if(pos_new->cell[coord] == block){
				pos_erase_block(pos_new, coord);
			}
			/* Ⴄނ̃ubNȂւsďI(S֘A̎dll) */
			else if(pos_new->cell[coord] >= 0){
				if(!disable_xcg){
					pos_new->block = pos_new->cell[coord];
					pos_new->cell[coord] = block;
				}
				break;
			}
			/* ̑̏QȂΕ]orI */
			else if(pos_new->cell[coord] == CELL_WALL ||
					(d_coord == -1 && pos_new->cell[coord] == CELL_PIPE_V) ||
					(d_coord != -1 && pos_new->cell[coord] == CELL_PIPE_H)){
				if(d_coord != -1){
					break;
				}
				else{
					/* ]KN */
					disable_xcg = 0;

					coord -= d_coord;
					d_coord = FLIPULL_W+2;
				}
			}
			/* 󔒂܂̓pCvȂΒPɒʉ */
			else{
			}
		}

		pos_update_effect(pos_new);
	}

	void prob2pos(const Problem* prob, Position* pos)
	{
		int x, y;
		int i;

		pos->quota = prob->quota;
		pos->num_block = 0;
		pos->block = prob->block;

		for(i = 0; i < NELEMS(pos->cell); ++i) pos->cell[i] = CELL_WALL;

		for(y = 0; y < FLIPULL_H; ++y){
			for(x = 0; x < FLIPULL_W; ++x){
				/* 1UPubNJEg邱Ƃɒ */
				if(prob->cell[y][x] >= 0) ++pos->num_block;
				pos_set_cell(pos, x, y, prob->cell[y][x]);
			}
		}

		pos_update_effect(pos);
	}

	int do_solve(const Position* pos, Solution* sol)
	{
		Position pos_new;
		int cell;
		//int coord_tmp;
		int y;

		if(pos->num_block <= pos->quota) return 1;

		// ォT
		//for(y = 0; y < FLIPULL_H; ++y){
		// T
		for(y = FLIPULL_H - 1; y >= 0; y--){
			cell = pos->cell[pos->effect[y]];
			if(cell < 0) continue;

			//coord_tmp = pos->effect[y];
			//while(pos->cell[coord_tmp] == CELL_EXTEND) coord_tmp += (pos->effect_dir[y] == DIR_H ? -1 : FLIPULL_W+2);
			//if(pos->block != BLOCK_WILD && pos->block != pos->cell[coord_tmp]) continue;

			if(pos->block != BLOCK_WILD && cell != CELL_EXTEND && pos->block != cell) continue;

			sol->move[sol->num_move++] = y;
			pos_proceed(pos, y, &pos_new);
			if(do_solve(&pos_new, sol)){
				return 1;
			}
			else{
				--sol->num_move;
			}
		}

		return 0;
	}

	int solve(const Problem* prob, Solution* sol)
	{
		Position pos;
	#if 0
		Position pos_new;
	#endif

		prob2pos(prob, &pos);
		//pos_print(&pos, stdout);

	#if 0
		pos_print(&pos, stdout);
		pos_proceed(&pos, 4, &pos_new);
		pos_print(&pos_new, stdout);
	#endif

		sol->sacrifice = 0;
		sol->num_move = 0;

		return do_solve(&pos, sol);
	}
};
