#include "stdafx.h"
#include "ImageProcessing.h"

namespace GBScreenCapture{
	// threshold𖳎܂B
	template<typename T>
	class NonThresholdPolicy{
	public:
		inline static bool Check(T err, T threshold){ return true; }
	};
	// 덷臒l傫ꍇ𒆒f܂B
	template<typename T>
	class UseThresholdPolicy{
	public:
		inline static bool Check(T err, T threshold){ return (err <= threshold);}
	};

	// NxN̗̈ɍł悭ev[gT
	template<int N, template<typename T> class ThresholdPolicy>
	int TemplateSelectionNxN(System::Drawing::Bitmap^ img, int x, int y, array<System::Drawing::Bitmap^>^ templates,int threshold){
		if(img == nullptr){
			throw gcnew System::ArgumentNullException("imgnullłB");
			return -1;
		}
		if(x < 0 || y < 0){
			throw gcnew System::ArgumentException("ʒuɂ͔񕉂̒lw肵ĂB");
			return -1;
		}
		if((x+1)*N > img->Width || (y+1)*N > img->Height){
			throw gcnew System::ArgumentOutOfRangeException("w肳ꂽʒuimgɑ΂đ傫܂B");
			return -1;
		}
		if(templates == nullptr){
			throw gcnew System::ArgumentNullException("templatesnullłB");
			return -1;
		}


		// img̕摜쐬
		System::Drawing::Bitmap^ ref_img = gcnew System::Drawing::Bitmap(N,N,img->PixelFormat);
		System::Drawing::Graphics^ g = System::Drawing::Graphics::FromImage(ref_img);
		System::Drawing::Rectangle rect = System::Drawing::Rectangle(x*N,y*N,N,N);
		g->DrawImage(img,0,0,rect,System::Drawing::GraphicsUnit::Pixel);

		int ret_idx = -1;
		int min_err = int::MaxValue;

		int nbtemplates = templates->GetLength(0);
		for(int i = 0; i < nbtemplates; i++){
			System::Drawing::Bitmap^ t = templates[i];
			// 傫NxNȂ΂
			if(t->Width < N || t->Height < N) continue;
			// NxŇ덷vZ
			int err = 0;
			for(int h = 0; h < N; h++){
				for(int w = 0; w < N; w++){
					System::Drawing::Color ref_color = ref_img->GetPixel(w,h);
					System::Drawing::Color tmp_color = t->GetPixel(w,h);
					err += System::Math::Abs(ref_color.R - tmp_color.R);
					err += System::Math::Abs(ref_color.G - tmp_color.G);
					err += System::Math::Abs(ref_color.B - tmp_color.B);
					// 덷臒l𒴂ł؂
					if(!ThresholdPolicy<int>::Check(err,threshold)){
						err = -1;
						break;
					}
				}
				if(err < 0) break;
			}
			if(err < 0) continue;
			// 덷菬Όɂ
			if(err < min_err){
				min_err = err;
				ret_idx = i;
			}
		}

		return ret_idx;

	}

	int ImageProcessing::TemplateSelection8x8(System::Drawing::Bitmap ^img, int x, int y, cli::array<System::Drawing::Bitmap ^,1> ^templates){
		return TemplateSelectionNxN<8,NonThresholdPolicy>(img,x,y,templates,-1);
	}
	int ImageProcessing::TemplateSelection8x8(System::Drawing::Bitmap ^img, int x, int y, cli::array<System::Drawing::Bitmap ^,1> ^templates, int threshold){
		if(threshold >= 0){
			return TemplateSelectionNxN<8,UseThresholdPolicy>(img,x,y,templates,threshold);
		}else{
			return TemplateSelectionNxN<8,NonThresholdPolicy>(img,x,y,templates,-1);
		}
	}
};